#!/usr/bin/env python
"""
======================COPYRIGHT/LICENSE START==========================

prodecomp.py: Part of PRODECOMP program

Copyright (C) 2008 Doroteya K. Staykova, Daniel Malmodin, Martin Billeter 
(University of Gothenburg, Sweden)

=======================================================================

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
======================COPYRIGHT/LICENSE END============================

for further information, please contact :
- our website (http://www.lundberg.gu.se/nmr/)
- dkstaykova@gmail.com, martin.billeter@chem.gu.se 

=======================================================================

If you are using this software for academic purposes, we suggest
quoting (one of) the following references:

===========================REFERENCE START=============================
Malmodin, D. and Billeter, M. (2005) Multiway Decomposition of NMR Spectra 
with Coupled Evolution Periods. J. Am. Chem. Soc., 127, 13486-13487. 

Malmodin, D. and Billeter, M. (2006) Robust and versatile interpretation 
of spectra with coupled evolution periods using multi-way decomposition. 
Magn. Reson. Chem., 44, S185-S195.

Staykova, D. K.; Fredriksson, J.; Bermel, W. and Billeter, M. (2008) 
Assignment of protein NMR spectra based on projections, multi-way decomposition 
and a fast correlation approach. J. Biomol. NMR., 42, 87-97.

===========================REFERENCE END===============================
"""

def docProjTools():
        """\
NMR Projections Analysis for Backbone Assignment Version 1.0 (08 May 2009 09:14:31)
\nCopyright (C) 2009 Doroteya K. Staykova, Daniel Malmodin, Martin Billeter
(University of Gothenburg, Sweden)
\nFor further help, please visit: http://www2.chem.gu.se/bcbp/nmr/
or contact: dkstaykova@gmail.com, martin.billeter@chem.gu.se 
        """
        pass

def runPROD(): guiPRODECOMP(root)
def runpk2intl(): pk2intl(root)
def runSHABBA(): comp2bba(root)
def openHelp(): os.system("gnome-open Manual.pdf")

#*************
# MAIN Program
#*************
#===additional modules:
from prodecomp import *
from peak2intls import *
from merge.MergeDefs import MergeDefs
from shabba.guicomp2assign import comp2bba

#===standart modules
from Tkinter import *
import tkMessageBox, os, sys

print docProjTools.__doc__ 
root = Tk()
ML = Toplevel(root, padx=50)
ML.title("NMR Projection Data Analysis")

MC = Canvas(ML, height=0, width = 500)
MC.pack(side=BOTTOM)

menubar = Menu(ML)
menubar.add_command(label="Merge definitions", activebackground='yellow', command = MergeDefs)
menubar.add_command(label="Generate Intervals", activebackground='yellow', command=runpk2intl)
menubar.add_command(label="PRODECOMP", activebackground='yellow', command=runPROD)
menubar.add_command(label="SHABBA ", activebackground='yellow', command= runSHABBA)
menubar.add_command(label="Help", activebackground='yellow', command=openHelp)
menubar.add_command(label="Quit!", activebackground='yellow', command=root.quit) 
ML.config(menu=menubar)                

root.withdraw()

if "idlelib" not in sys.modules:
    root.mainloop()
