#==Function for merging definition files (format: Wolfgang Bermel, Bruker)
def MergeDefs():
        #== Function for reading a defs from WB file
        # Input: the content of a definition file
        def ReadDefs(buf):
		ntype, swppm, swhz, o1ppm = [[] for i in range(4)]
		for j, row in enumerate(buf):
			if len(row.split()):
                		if row.split()[0]=='NUCLEI=': 
                        		ntype = row.split()[2].split(',')[0]
                        		for k in row.split()[3::]: ntype = ntype + ' ' + k.split(',')[0]                        
                        	elif row.split()[0]=='SW_ppm=':
                                	swppm = row.split()[2].split(',')[0]
                                	for k in row.split()[3::]: swppm = swppm + ' ' + k.split(',')[0]
                        	elif row.split()[0]=='SW_hz=':
                                	swhz = row.split()[2].split(',')[0]
                                	for k in row.split()[3::]: swhz = swhz + ' ' + k.split(',')[0]
                        	elif row.split()[0]=='O1_ppm=':
                                	o1ppm = row.split()[2].split(',')[0]
                                	for k in row.split()[3::]: o1ppm = o1ppm + ' ' + k.split(',')[0]
                
		output = [ntype, swppm, swhz, o1ppm]
		if all([len(x) for x in output]): return output
                else: 
                        tkMessageBox.showerror(title=None, message="The DEFINITION file is not recognised.")
			return

        #==Function for generating strings from list
        def inp2str(row,inlist):
                Lvar = row.split()[0:2]+inlist
                output=Lvar[0]+' '
                for m in range(1,len(Lvar)-1): output=output+Lvar[m]+' '
                output=output+Lvar[-1]+'\n'

                return output

        #==Function for generating defs from list
        # row-> read definition row ('str'), Ltot-> combined nuclei ('list'), Lbuf-> nuclei in the file ('list') 
        def def2str(row, Ltot, Lbuf):
                Lin = [x.split(',')[0] for x in row.split()[2::]]
                Lout = [[] for x in range(len(Ltot))]
                for i in range(len(Ltot)):
                        indx = [x for x in range(len(Lbuf)) if Lbuf[x] == Ltot[i]]
                        # Assuming a nuclei is given only once in a NUCLEI: definition.
                        if len(indx): Lout[i]= Lin[indx[0]]
                        else:  Lout[i]= str(0)
                Lout = [x+',' for x in Lout[0:-1]]+[Lout[-1]]
                return Lout

        NucType, SW, SW_hz, O1, NameFiles = [[] for x in range(5)]
        f = askopenfile(title='Select DEFINITION file')
        try: 
                buf = f.readlines()
                f.close()
                
                NucType.append(ReadDefs(buf)[0]) 
                SW.append(ReadDefs(buf)[1])	
                SW_hz.append(ReadDefs(buf)[2])
                O1.append(ReadDefs(buf)[3])
                NameFiles.append(f.name)
                while tkMessageBox.askokcancel(title=None, message="Do you want to add another DEFINITION file?"):
                        f = askopenfile(title='Select DEFINITION file')
                        try:
                                buf = f.readlines()
                                f.close()
                                if f.name not in NameFiles: 
                                        NucType.append(ReadDefs(buf)[0])
                                        SW.append(ReadDefs(buf)[1])
                                        SW_hz.append(ReadDefs(buf)[2])
                                        O1.append(ReadDefs(buf)[3])
                                        NameFiles.append(f.name)
                        except: tkMessageBox.showerror(title=None, message="Problem with file opening.")
                        
        except: tkMessageBox.showerror(title=None, message="Problem with file opening.")
	
        if all([len(NucType),len(SW), len(SW_hz), len(O1), len(NameFiles)]):	
                # Merging the header, assuming the number of elements is const 
                for i, nt in enumerate(NucType):
                        if not i: CombType, CombSW, CombSW_hz, CombO1 = [x.split() for x in [NucType[0],SW[0],SW_hz[0],O1[0]]]			
                        else:  
                                indx = [x for x in range(len(nt.split())) if nt.split()[x] not in CombType]				
                                CombType = CombType + [nt.split()[x] for x in indx]
                                CombSW = CombSW + [SW[i].split()[x] for x in indx]
                                CombSW_hz = CombSW_hz + [SW_hz[i].split()[x] for x in indx]
                                CombO1 = CombO1 + [O1[i].split()[x] for x in indx]
                CombType = [x+',' for x in CombType[0:-1]]+[CombType[-1]]
                CombSW = [x+',' for x in CombSW[0:-1]]+[CombSW[-1]]
                CombSW_hz = [x+',' for x in CombSW_hz[0:-1]]+[CombSW_hz[-1]]
                CombO1 = [x+',' for x in CombO1[0:-1]]+[CombO1[-1]]
                # Merging the definition files
                Ldefs = []
                Ltot = [x.split(',')[0] for x in CombType]
                count = 0
		
                for j, nf in enumerate(NameFiles):
                        f = open(nf,'r')
                        buf = f.readlines()
                        f.close()
                        if not j: 
                                bufout = list(buf)
                                for k,row in enumerate(buf):
					if len(row.split()):
                                        	if row.split()[0]=='NUCLEI=': 
                                                	bufout[k]= inp2str(row,CombType)
                                                	Lbuf = [x.split(',')[0] for x in row.split()[2::]]					
                                        	elif row.split()[0]=='SW_ppm=':bufout[k]= inp2str(row,CombSW)
                                        	elif row.split()[0]=='SW_hz=':bufout[k]= inp2str(row,CombSW_hz)
                                        	elif row.split()[0]=='O1_ppm=':bufout[k]= inp2str(row,CombO1)
                                        	elif row.split()[0]=='DEFINITION:':
                                                	count = count+1
                                                	Lout = def2str(row, Ltot, Lbuf)
                                                	bufout[k] = 4*' '+inp2str(row,Lout)
							bufout[k-1] = str(count)+'='+bufout[k-1].split('=')[1]				
                        else: 
                                for k,row in enumerate(buf):
					if len(row.split()):
                                        	if row.split()[0]=='NUCLEI=': Lbuf = [x.split(',')[0] for x in row.split()[2::]]
                                        	elif row.split()[0]=='DEFINITION:':
                                                	count = count+1
                                                	Lout = def2str(row, Ltot, Lbuf)
                                                	bufout.append(str(count)+'='+buf[k-1].split('=')[1])
                                                	bufout.append(4*' '+inp2str(row,Lout))
							
		f = asksaveasfilename()
		try:
        		f=open(f,'w')
        		[f.writelines(x) for x in bufout if len(x.split())]
        		f.close()
		except: tkMessageBox.showerror(title=None, message="No file name was given.")								
                
        else: tkMessageBox.showerror(title=None, message="An error while processing definition files occurs.")
	return
        

#==MAIN
from tkFileDialog import *
import tkMessageBox

if __name__ == "__main__":
	import pdb
	MergeDefs()
