class pk2intl (object):
        def __init__(self, master):
                self.master = master		
                self.TL = Toplevel(master, pady = 10, padx = 50)
                self.TL.title("Peak list (2D) -> list of intervals ")

		Button(self.TL,text='Open peak list', bg = "yellow", command=self.loadPkList).grid()
		Label(self.TL,text ='\n').grid()

		PkPar = ['HN shift, ppm\n(column, 0..n)','N shift, ppm\n(column, 0..n)','Peak intensity\n(column, 0..n)']
		CalcPar	= ['No of points (m),\ni.e. 2*m interval','Factor (f) for neighbour,\ni.e. f*2*m interval',\
				'Intensity function I ,i.e.\nGaussian (1) / Lorentzian(2)','HWHM parameter, \npoints',\
				'Treshold for I(x1)/I(x0)\n-> +1 component']
		initCPar = [2.5, 10, 1, 2, 0.3]		
		frmPkPar = Frame(self.TL)
		frmPkPar.grid(sticky='nswe')
		Label(frmPkPar,text='Parameters from the peak list', bd = 5, bg = 'dark gray', fg = 'white').grid(column = 0, columnspan=2, sticky='nswe')
		self.param=[]
		for i in range(len(PkPar)):
			Label(frmPkPar,text=PkPar[i], bd = 5).grid(row = i+2, column = 0)
			e = Entry(frmPkPar, width=8, bg = 'white', relief=RIDGE)
                        e.grid(row = i+2, column = 1)
                        self.param.append(e)

		Label(self.TL,text ='\n').grid()
		frmCalPar = Frame(self.TL)
		frmCalPar.grid(sticky='nswe')
		Label(frmCalPar,text='Parameters for interval calculation', bd = 5, bg = 'dark gray', fg = 'white').grid(column=0, columnspan=2,sticky='nswe')
		for i in range(len(CalcPar)):
			Label(frmCalPar,text=CalcPar[i], bd = 5).grid(row = i+1, column = 0)
			e = Entry(frmCalPar, width=8, bg = 'white', relief=RIDGE)
                        e.grid(row = i+1, column = 1)
			e.insert(END, initCPar[i])
                        self.param.append(e)

		Label(self.TL,text ='\n').grid()
		Button(self.TL,text='Output results', bg = "yellow", command=self.outIntls).grid()
		
		[x.config(state=DISABLED) for x in self.param]

	def loadPkList(self, event=None):
		filein = askopenfile(title='Select FILE with 2D peaks')
        	self.fin = filein.name
		[x.config(state=NORMAL) for x in self.param]

	def outIntls(self, event=None):
		col, colN, colI, m, mpar, peakf, n, tresh = [float(x.get()) for x in  self.param]					
                result = peak2comp(self.fin, col, colN, colI, m, mpar, peakf, n, tresh)	
		fileout = asksaveasfilename(title='File to save the results')
		f = open(fileout,'w')
		header = 'Peak list->'+ self.fin + '\n'\
			+'Half interval for component, m->' + self.param[3].get()+ '\n'\
			+'Factor for neighbour, i.e.f*2*m interval, f->'+ self.param[4].get()+ '\n'\
			+'Intensity function Gauss(1)/Lorentz(2), I->'+ self.param[5].get()+ '\n'\
			+'HWHM parameter->'+ self.param[6].get()+ '\n'\
			+'Intensity treshold for adding component->'+ self.param[7].get()+ '\n\n'
		f.write(header)		
		f.close()			
		f = open(fileout,'a')
        	f.writelines(result)
        	f.close()
		self.TL.destroy()


from func_pk2intl import *
from Tkinter import *
from tkFileDialog import *

if __name__ == "__main__":
	root = Tk()        
        app = pk2intl(root)
        root.withdraw()
	root.mainloop()
