from scipy.optimize import leastsq
from numpy import array, exp, log
from numpy import sum as nSum

#==Function for fitting a shape (HN)
def fitshape(shp, DirSize, offset, ftype, SW, MAX):			
            # Functions for calculating the difference between data and fitting functions
            # 'func' and 'ftype' take 'G' for Gaussian and 'L' for Lorentzian functions, resp.			
            def residuals(p, y, x, func):    
                    A, fmu, fsigma = p
                    if func == 'G': err = array(y) - A * exp(-log(2)*((x-fmu)/fsigma)**2)
                    elif func == 'L': err = array(y) - A/(1+((x-fmu)/fsigma)**2)
                    return err

            def peval(x,p, func):
                    if func == 'G':	return p[0]*exp(-log(2)*((array(x)-p[1])/p[2])**2)
                    elif func == 'L': return p[0]/(1+((array(x)-p[1])/p[2])**2)

            # INITIALIZE the fit parameters
            # Amplitude (A); peak position (fmu); parameter~FWHM (fsigma)
            pt = range(offset,offset+len(shp))
            A = max(shp) 
            indx = shp.index(max(shp))		
            fmu = pt[indx]
            fsigma = 2
            p0 = [A, fmu, fsigma]

            # FIT the data: "leastsq" - non-linear least square minimizer 
            # plsq[0] gives fit parameters; plsq[1]=1: fit converged
            plsq = leastsq(residuals, p0, args=(shp,pt,ftype))
            # estimate of the goodness of the fit: nSum([data-estimate]^2)/Np
            par = nSum((array(shp)-peval(pt,plsq[0],ftype))**2)/len(shp)	
            # PLOT (requires pylab)			 
            #plot(pt,peval(pt,plsq[0],ftype),'r', pt,shp,'ok')
            #show()	
            # CONVERSION to ppm 	
            Peakppm = plsq[0][1]*(-SW/(DirSize-1))+MAX 
            return [[plsq[0][1]], [Peakppm], [100.0]]	

