#==Function for loading decomposition components from a file (output of Prodecomp GUI)
# Output: Lists with indirect and direct shapes(float) with list of offsets (strings)) and lists of nuclei types, sw, o1, size (strings)
def LoadComp():			
        fin = tkFileDialog.askopenfile(title='Select FILE with decomposition results')
	try:	
        	buf = fin.readlines() 
		fin.close() 		
        	Ldshp, Offset = [], [] # Initializing the lists ofr direct shapes and offsets	
		for i, row in enumerate(buf):
			if row.find('NUCLEI=')!=-1: 
				NucType = [x.strip() for x in row.split('=')[1].split(',')]
				Lindshp = [[] for x in range(len(NucType)-1)]	# Initializing the list for inidirect shapes
			elif row.find('SW_ppm=')!=-1: SWppm = [x.split(')')[0].strip() for x in row.split('= (')[1].split(',')]
			elif row.find('O1_ppm=')!=-1: O1ppm = [x.split(')')[0].strip() for x in row.split('= (')[1].split(',')]
			elif row.find('SIZE=')!=-1: Size = [x.split(')')[0].strip() for x in row.split('= (')[1].split(',')]
			elif all([ord(row.split()[0][0])>= 48, ord(row.split()[0][0])<= 57]): # data start when lines begin with a number
				dpath = row.split()[2]
				slist = []
				# check if path to data exist
                                if os.path.exists(dpath):					
 					Offset.append(row.split()[2].split(os.sep)[-2].split('_')[0])
					for jf in glob.glob(dpath+'f*c'+buf[i+1].split(':')[1].split()[0]):
                                                slist.append(jf.split(dpath)[-1])
                                                if slist[-1].find('fdir')==-1:
                                                        numsh = int(slist[-1].split('s')[-1].split('c')[0])
                                                        # reading the shape from file: slist[-1]
                                                        f = open(dpath+slist[-1],'r')
                                                        bufsh = f.readlines()
                                                        f.close()
                                                        vecsh = []
                                                        for k in range(len(bufsh)):
                                                                vecsh.append(float(bufsh[k].split()[0]))
                                                        # 2D matrix for each shape->(Ncomp,shape's size)
                                                        if len(Lindshp[numsh-1]): Lindshp[numsh-1]=concatenate((Lindshp[numsh-1],array([vecsh])))
                                                        else: Lindshp[numsh-1]= array([vecsh])
                                                        
                                                else:					
                                                        f = open(dpath+slist[-1],'r')
                                                        bufsh = f.readlines()
                                                        f.close()
                                                        vecsh = []					
                                                        for k in range(len(bufsh)): vecsh.append(float(bufsh[k].split()[0]))
                                                        Ldshp.append(vecsh)
		
		return Lindshp, Ldshp, Offset, NucType, SWppm, O1ppm, Size   
		
	except: 
		tkMessageBox.showerror(title=None, message='The file can not be open.')
		return
	
import tkFileDialog, tkMessageBox, glob, os
from numpy import array, concatenate

if __name__ == "__main__":
	import pdb
	test = LoadComp()
	pdb.set_trace()
