#==Modul for matching shapes of Cab(i-1) with Ca/Cb
# Function for analysing an input from one component and giving as an output(Cai-1,Cbi-1,Cai,Cbi)
# Input: Peaks/Intens-> 3 lists of peaks for Cabi-1, Cai, Cbi; 
# CSdiff-> ppm difference in peak in Cabi-1 and Cai/Cbi
# !Important: expected maximum 2 peaks per shape (Npeaks)
def FuncCompar(Peaks, Intens, CSdiff, Tresh):
	#==Ist step: Taking from Cab(i-1), Ca/Cb peaks the two strongest ones
	Npeaks=2
	Iter1 = []
	for i, var in enumerate(Peaks):
		if len(var)==1:Iter1.append(var)
		elif len(var)>1:
			param = []					
			for elem in sorted(Intens[i], reverse=True)[0:Npeaks]:	# Taking the number (Npeaks) of strongest peaks  
				if elem>Tresh: param = param+[var[x] for x in range(len(Intens[i])) if Intens[i][x]==elem]
			Iter1.append(param)						
		else: Iter1.append([])

	#==IInd step: Matching shapes assuming Iter1: 1st shape-> Cab(i-1), 2nd->Ca, 3rd->Cb
	CabComp = [[] for i in range(4)] #-> (Cai-1,Cbi-1,Cai,Cbi)
	if len(Iter1[1])==1: CabComp[2]=Iter1[1][0]	# only one peak in Ca
	if len(Iter1[2])==1: CabComp[3]=Iter1[2][0]	# only one peak in Cb
	if len(Iter1[0])==1:
		if all([Iter1[0][0]>45,Iter1[0][0]<56]):
			CabComp[0]=Iter1[0][0]	# check for Gly in Cabi-1
			# IMPORTANT: Cai-1 (Gly)  appear in Cbi of neighbour
			var0 = [x for x in Iter1[2] if not all([x<CabComp[0]+CSdiff, x>CabComp[0]-CSdiff])]
			if len(var0)==1:CabComp[3] = var0[0] # Cbi			

	if all([CabComp[0]==[],CabComp[1]==[]]):	
                cond1 = [x for x in Iter1[0] if x<44]	# check for Cbi-1
                if len(cond1)==1: 
                        CabComp[1] = cond1[0]	# Cbi-1
                        if CabComp[3]==[]: # Cb has 2 peaks 
                                var1 = [x for x in Iter1[2] if not all([x<CabComp[1]+CSdiff, x>CabComp[1]-CSdiff])]	# exclude Cbi-1 peak in Cb 
                                if len(var1)==1: CabComp[3] = var1[0] # Cbi 
                                
                        cond2 = [x for x in Iter1[0] if x!=cond1[0]]
                        if len(cond2): 
                                CabComp[0] = cond2[0] # Cai-1 	
                                if CabComp[2]==[]: # Ca has 2 peaks
                                        var2 = [x for x in Iter1[1] if not all([x<CabComp[0]+CSdiff, x>CabComp[0]-CSdiff])]	# exclude Cai-1 peak in Ca 
                                        if len(var2)==1:CabComp[2] = var2[0] # Cai

                elif not len(cond1):	# both peaks can be Cai-1 or Cbi-1
                        for j, pk in enumerate(Iter1[0]):
                                if len(Iter1[1])>1: case1 = [x for x in Iter1[1] if all([x<pk+CSdiff, x>pk-CSdiff])] # compare with Ca shape (if it has more then 1 peak)
				else: case1 = []
                                if len(Iter1[2])>1:case2 = [x for x in Iter1[2] if all([x<pk+CSdiff, x>pk-CSdiff])] # compare with Cb shape (if it has more then 1 peak)
				else: case2 = []
                                if len(case1)==1: 
                                        CabComp[0]=pk	# Cai-1
                                        cond3 = [x for x in Iter1[0] if x!=pk]
                                        if len(cond3): 
                                                CabComp[1] = cond3[0] # Cbi-1
                                                cond3_1 = [x for x in Iter1[2] if not all([x<CabComp[1]+CSdiff, x>CabComp[1]-CSdiff])]
                                                if all([CabComp[3]==[], len(cond3_1)==1]): CabComp[3] = cond3_1[0] # Cbi
                                        if CabComp[2]==[]: CabComp[2] = [x for x in Iter1[1] if x!=case1[0]][0] # Cai
                                        break

                                if len(case2)==1: 
                                        CabComp[1]=pk # Cbi-1
                                        cond4 = [x for x in Iter1[0] if x!=pk]
                                        if len(cond4):
                                                CabComp[0]= cond4[0] # Cai-1
                                                cond4_1 = [x for x in Iter1[1] if not all([x<CabComp[0]+CSdiff, x>CabComp[0]-CSdiff])]
                                                if all([CabComp[2]==[], len(cond4_1)==1]):CabComp[2]= cond4_1[0] # Cai
                                        if CabComp[3]==[]:CabComp[3] = [x for x in Iter1[2] if x!=case2[0]][0] # Cbi				
                                        break
	# If both peaks Cabi-1 > 44 and don't match with any of Cai/Cbi -> result ambigous for Cabi-1 and not used for placing the chains
	if all([CabComp[2]==[], Iter1[1]!=[]]): CabComp[2] = Iter1[1][0] # Cai gets the one with the srongest intensity
	if all([CabComp[3]==[], Iter1[2]!=[]]): CabComp[3] = Iter1[2][0] # Cbi, the same
	
	return CabComp

if __name__ == "__main__":
	import pdb
	
	#output = FuncCompar(Peaks, Intens)
	output = FuncCompar([[80.772499999999994, 76.631499999999988, 74.560999999999993, 70.419999999999987, 62.828166666666661], [64.898666666666657, 62.137999999999998, 53.165833333333332],\
				[46.954333333333331, 30.390333333333331, 11.755833333333342, 6.924666666666667]], [[5.5999999999999996, 5.7999999999999998, 7.0999999999999996, 100.0, 54.799999999999997],\
				[0.59999999999999998, 41.5, 100.0], [100.0, 3.5, 1.3, 0.90000000000000002]], 0.7, 5.0)
	
	pdb.set_trace()
