#==Modul for matching shapes of Hab(i-1) with Ha/Hb
# Peaks: Ordered peak lists, 1: Habi-1, 2:Ha, 3:Hb
# Npeaks: number of peaks for Hai-1, Hbi-1, Ha and Hb from residue type
# Output: Lists for each one: Hai-1, Hbi-1, Ha, Hb
def FuncHaHb(Peaks, Intens, Npeaks, CSdiff):
	delta = 2. # Check if H peaks are noise (difference between Hb2,Nb3 or Ha1,Na2 can not be bigger then 2 ppm (actual value is 0.5-1 ppm))
	maxNH = [Npeaks[0],Npeaks[1]]	# maxium additional [Ha, Hb] peaks coming from i-1 residue
	if all([Npeaks[0]==2, Npeaks[3]!=0]): maxNHaHb = [Npeaks[2],Npeaks[3]+Npeaks[0]]	# Gly is i-1-component-> Hai-1 appear in Hbi
	elif all([Npeaks[2]==2, Npeaks[1]!=0]):	maxNHaHb = [Npeaks[1]+Npeaks[2],Npeaks[3]]	# Gly is i-component-> Hbi-1 appear in Hai (moved from Hbi)  
	else: maxNHaHb = [Npeaks[2]+Npeaks[0],Npeaks[3]+Npeaks[1]]
	# peak position-Iter1, intensity-Iter2
	Iter1, Iter2 = [], []
	for i, var in enumerate(Peaks):		
		if len(var)==1:
			Iter1.append(var)
			Iter2.append(Intens[i])
		elif len(var)>1:
			param, intparam = [], []
			if not i: Npks = sum(maxNH)
			else: Npks = maxNHaHb[i-1]			
			for elem in sorted(Intens[i], reverse=True)[0:Npks]:	# Taking the number (Npks) starting from the strongest  
				param = param+[var[x] for x in range(len(Intens[i])) if Intens[i][x]==elem]
				intparam = intparam+[x for x in Intens[i] if x==elem]
			Iter1.append(param)
			Iter2.append(intparam)			
		else: 
			Iter1.append([])
			Iter2.append([])
	
	# Iter1[0]: Habi-1, Iter1[1]: Ha, Iter1[2]: Hb Peaks are ordered with decreasing intensity 
	HabComp = [[] for i in range(4)] #-> (Hai-1,Hbi-1,Hai,Hbi)
	HabInt = [[] for i in range(4)] #-> (Intensities for Hai-1,Hbi-1,Hai,Hbi)
	if len(Iter1[1])==1: 
		HabComp[2]=[Iter1[1][0]]	# only one peak in Ha
		HabInt[2]=[Iter2[1][0]]
	if len(Iter1[2])==1: 
		HabComp[3]=[Iter1[2][0]]	# only one peak in Hb
		HabInt[3]=[Iter2[2][0]]
	
	# For Gly	
	if all([Npeaks[2]==2,Npeaks[3]==0]):	# Gly as i-component
		if HabComp[2]==[]:
			indx =  [x for x in range(len(Iter1[1])) if all([Iter1[1][x]<6.5,all([abs(Iter1[1][x]-y)>CSdiff for y in Iter1[0]])])]
			var0 = [Iter1[1][x] for x in indx]
			if len(var0)>2: 
				HabComp[2]=var0[0:2]	# Ha
				HabInt[2]=[Iter2[1][x] for x in indx][0:2] # Ha-intensity
			else: 
				HabComp[2]=var0
				HabInt[2]=[Iter2[1][x] for x in indx]
			if not Npeaks[0]==2: 
				ind_left0 = [x for x in range(len(Iter1[0])) if any([abs(Iter1[0][x]-y)<CSdiff for y in Iter1[1]])]
				left0 = [Iter1[0][x] for x in ind_left0]  
				if len(left0): 
					HabComp[1]=list(left0) # Hbi-1 in Hai
					HabComp[0]=[x for x in Iter1[0] if x not in HabComp[1]]
					HabInt[1] = [Iter2[0][x] for x in ind_left0]
					HabInt[0]=[Iter2[0][x] for x in range(len(Iter1[0])) if Iter1[0][x] not in HabComp[1]]
		# remove noise peaks: different more then 2 ppm
		if len(HabComp[2])>1: 
			HabComp[2]=[x for x in HabComp[2] if abs(x-HabComp[2][0])<delta]
			HabInt[2] = [HabInt[2][x] for x in range(len(HabComp[2])) if abs(HabComp[2][x]-HabComp[2][0])<delta]
	
	if all([Npeaks[0]==2,Npeaks[1]==0]):	# Gly as i-1-component
			HabComp[0] = [x for x in Iter1[0] if abs(x-Iter1[0][0])<delta]	# Hai-1
			HabInt[0] = [Iter2[0][x] for x in range(len(Iter1[0])) if abs(Iter1[0][x]-Iter1[0][0])<delta] # Hai-1 intensity
			if not Npeaks[3]==0: 
				HabComp[3] = [x for x in Iter1[2] if all([abs(x-y)>CSdiff for y in HabComp[0]])] # Hb
				HabInt[3] = [Iter2[2][x] for x in range(len(Iter1[2])) if all([abs(Iter1[2][x]-y)>CSdiff for y in HabComp[0]])] # Hb intensity
	
	if all([Npeaks[0]!=2, Npeaks[2]!=2]):	# No Gly in the component		
                if len(Iter1[1]):
                        var1 = [x for x in Iter1[1] if any([abs(x-y)<CSdiff for y in Iter1[0]])]
                        if len(var1): 
                                HabComp[0]=[x for x in Iter1[0] if any([abs(x-y)<CSdiff for y in var1])]	# Hai-1 found as match in Ha
                                HabComp[1] = [x for x in Iter1[0] if x not in HabComp[0]] # The rest are Hbi-1
				HabInt[0]=[Iter2[0][x] for x in range(len(Iter1[0])) if any([abs(Iter1[0][x]-y)<CSdiff for y in var1])] # Hai-1 intensity
				HabInt[1] = [Iter2[0][x] for x in range(len(Iter1[0])) if Iter1[0][x] not in HabComp[0]] # Hbi-1 intensity
                                if HabComp[2]==[]: 
					HabComp[2]=[x for x in Iter1[1] if x not in var1] # Ha
					HabInt[2]=[Iter2[1][x] for x in range(len(Iter1[1])) if Iter1[1][x] not in var1]  # Ha intensity
                                if all([HabComp[3]==[],HabComp[1]!=[]]): 
					HabComp[3] = [x for x in Iter1[2] if all([abs(x-y)>CSdiff for y in HabComp[1]])] # Hb
					HabInt[3] = [Iter2[2][x] for x in range(len(Iter1[2])) if all([abs(Iter1[2][x]-y)>CSdiff for y in HabComp[1]])] # Hb intensity
                        
                        else: # Hai-1 not found in Ha
                                if HabComp[2]==[]: 
					HabComp[2]=Iter1[1]	# Ha
					HabInt[2]=Iter2[1]
                                # look in Hb
                                var2 =  [x for x in Iter1[2] if any([abs(x-y)<CSdiff for y in Iter1[0]])]
                                if len(var2):
                                        HabComp[1]=[x for x in Iter1[0] if any([abs(x-y)<CSdiff for y in var2])]	# Hbi-1 found as match in Hb
					HabInt[1]=[Iter2[0][x] for x in range(len(Iter1[0])) if any([abs(Iter1[0][x]-y)<CSdiff for y in var2])]	# Hbi-1 intensity
                                        if len([x for x in Iter1[0] if x not in HabComp[1]])==1: 
						HabComp[0]= [x for x in Iter1[0] if x not in HabComp[1]] # Hai-1
						HabInt[0] = [Iter2[0][x] for x in range(len(Iter1[0])) if Iter1[0][x] not in HabComp[1]] # Hai-1 intensity
                                        if HabComp[3]==[]: 
						HabComp[3]= [x for x in Iter1[2] if x not in var2]	# Hb
						HabInt[3]= [Iter2[2][x] for x in range(len(Iter1[2])) if Iter1[2][x] not in var2] # Hb intensity
				else:# Hbi-1 not found in Hb
					if HabComp[3]==[]:
						HabComp[3]=Iter1[2]	# Hb
						HabInt[3]=Iter2[2]
                        
                elif len(Iter1[2]):
                        var3 = [x for x in Iter1[2] if any([abs(x-y)<CSdiff for y in Iter1[0]])]
                        if len(var3):
                                HabComp[1]=[x for x in Iter1[0] if any([abs(x-y)<CSdiff for y in var3])]	# Hbi-1 found as match in Hb
				HabInt[1]=[Iter2[0][x] for x in range(len(Iter1[0])) if any([abs(Iter1[0][x]-y)<CSdiff for y in var3])] # Hbi-1 intensity
                                if len([x for x in Iter1[0] if x not in HabComp[1]])==1: 
					HabComp[0] = [x for x in Iter1[0] if x not in HabComp[1]] # The other is Hai-1 
					HabInt[0] = [Iter2[0][x] for x in range(len(Iter1[0])) if Iter1[0][x] not in HabComp[1]]
                                if HabComp[3]==[]: 
					HabComp[3]=[x for x in Iter1[2] if x not in var3] # Hb
					HabInt[3]=[Iter2[2][x] for x in range(len(Iter1[2])) if Iter1[2][x] not in var3]
                        else: # Hbi-1 not found in Hb
                                if HabComp[3]==[]: 
					HabComp[3]=Iter1[2]	# Hb
					HabInt[3]=Iter2[2]
                
	# Check if Hb peaks are noise 
	if Npeaks[3]==2:
		if len(HabComp[3])>1: 
			HabComp[3]=[x for x in HabComp[3] if abs(x-HabComp[3][0])<delta]
			HabInt[3]=[HabInt[3][x] for x in range(len(HabComp[3])) if abs(HabComp[3][x]-HabComp[3][0])<delta]
	if Npeaks[1]==2:
		if len(HabComp[1])>1: 
			HabComp[1]=[x for x in HabComp[1] if abs(x-HabComp[1][0])<delta]
			HabInt[1]=[HabInt[1][x] for x in range(len(HabComp[1])) if abs(HabComp[1][x]-HabComp[1][0])<delta]
	# Check if the number of peaks is correct
	for k in range(4): 
		if len(HabComp[k])>Npeaks[k]: 
			HabComp[k]=HabComp[k][0:Npeaks[k]]
			HabInt[k]=HabInt[k][0:Npeaks[k]]
	
	return HabComp, HabInt				
	

if __name__ == "__main__":
	import pdb
	# comp70-i-1 of Pro: problem->Hai-1 shift goes in Hbi-1, found in Hbi with 20% intensity
	#output = FuncHaHb([[4.0761750000000001, 2.4099750000000002, 1.9240000000000004], [7.7557, 6.7837500000000004, 4.3538750000000004, 2.6876750000000005], \
	#		[4.0761750000000001, 3.72905, 2.4099750000000002, 1.9240000000000004]],[[100.0, 48.299999999999997, 36.0], [5.5, 5.2999999999999998, 100.0, 6.2000000000000002],\
	#		 [19.800000000000001, 100.0, 32.799999999999997, 29.0]], [1, 2, 1, 2],0.05)
	
	output = FuncHaHb([[4.8398500000000002, 2.5488249999999999, 1.2297500000000001], [5.6035250000000003, 5.1869750000000003, 4.9092750000000001, 3.5902000000000003], \
			[2.4099750000000002, 1.8545750000000005, 1.6463000000000001, 1.299175]], [[100.0, 7.4000000000000004, 4.5], [8.3000000000000007, 10.9, 81.099999999999994, 100.0], \
			[100.0, 26.800000000000001, 22.0, 36.299999999999997]],[1,1,1,1],0.05)
	pdb.set_trace()

